;Copyright 2000 - Mark McDonald All rights reserved
; DECLARE: FUNCTION isaltp() AS INTEGER
; DESC:    Returns true if an ALT shift key is being pressed.
; EXAMP:   IF isaltp THEN GOTO ....
; ISALTP()
;     Is Alt Key Pressed.
;     Returns 1 if Alt key is pressed.
;     Returns 0 if not.
;     EXAMPLE:  T = ISALTP       1

MCODE Segment Byte
        Assume  CS: MCODE

        Public  isaltp

isaltp Proc Far
        push    ES                      ;

        xor     AX,AX                   ; clear AX
        mov     ES,AX                   ; set ES to BIOS data segment
        test    Byte Ptr ES: [417h],8   ; test the Alt Key bit
        jz      Exit                    ; if 0, exit
        inc     AX                      ; else return  1
Exit:
        pop     ES                      ;
        retf
isaltp EndP
MCODE EndS
        End
