;Copyright 2000 - Mark McDonald All rights reserved
; DECLARE: FUNCTION ISCTRLBREAK() AS INTEGER
; DESC:    Return the status of Ctrl-Break checking by DOS.
; EXAMP:   Status = ISCTRLBREAK
; ISCTRLBK()
;     Is Control Break key combination pressed.
;     Returns 1 if CTRL-BREAK/C checking is set.
;     Returns 0 if not.
;     EXAMPLE:  T = ISCTRLBK

MCODE   Segment Byte
        Assume  CS: MCODE

        Public  ISCTRLBK

ISCTRLBK Proc Far

        push    DS                      ;

        mov     AX, 3300h               ; get Ctrl-Break checking status
        int     21h                     ; call DOS
        xor     AX, AX                  ; clear AX
        mov     AL, DL                  ; put status in AL

        pop     DS                      ;
        retf                            ;
ISCTRLBK EndP
MCODE   EndS
        End
