; pbtFreeDosRam routine for PowerBASIC
; Copyright (c) 1993,94 by Dave Navarro, Jr.
; Last Revision: September 23, 1993
; PROC:    pbtFreeDosRam
; CLASS:   SYSTEM
; DECLARE: FUNCTION pbtFreeDosRam() AS DWORD
; DESC:    Return the amount of free RAM as bytes.  This is the amount of
;          memory that is left after your program ends.
; EXAMP:   PRINT "Free Ram:"; pbtFreeDosRam
pbtCode    Segment Byte
        Assume  CS: pbtCode
        Public  pbtFreeDosRam
pbtFreeDosRam Proc    Far
        int     12h              ; call BIOS to get installed RAM
        mov     BX, 64           ; Multiply by 64 to account for blocks
        mul     BX               ; AX = AX * BX
        mov     CX, AX           ; save it in CX
        mov     AH, 62h          ; Get PSP of current program
        int     21h              ; call DOS
        sub     CX, BX           ; subtract ourselves
        mov     AX, CX           ; move to AX
        mov     BX, 16           ; multiply by 16 to calculate bytes
        mul     BX               ; DX:AX = AX * BX
        retf                            ;
pbtFreeDosRam Endp
pbtCode    Ends
        End
