;Copyright 2000 - Mark McDonald All rights reserved
; DECLARE: FUNCTION triml(BYVAL string,nbr)
; DESC:    Returns string where left most nbr are removed.
; EXAMP:   A$ = triml("hello",1)  'ello'

Extrn   Get$Loc: Far
Extrn   Get$Alloc: Far
Extrn   Rls$Alloc: Far

MCODE Segment Byte
        Assume  CS: MCODE

        Public  triml

triml Proc Far

ARG     startnbr: WORD, StrHandle: WORD = Retbytes
;--- Save PowerBasic Registers ---
        push    BP                      ;
        mov     BP,SP                   ;
        push    DS                      ;
;--- Get Passed String Location ---
        mov     AX,StrHandle            ; push string handle in AX
        push    AX                      ; push it on the on stack
        call    Get$Loc                 ; get location of the string
        mov     DS,DX                   ; put segment in DS
        mov     SI,AX                   ; put offset in SI
        xor     AX,AX                   ; assume null string
        jcxz    Exit                    ; is it null?
;--- Number of characters to Lop off gt length? ---
        cmp     CX,Startnbr
        jz      Exit
        js      Exit
;--- Position Pointer to end of string ---
        add     SI,CX
;--- Create New PowerBasic String ---
        sub     CX,Startnbr
        push    CX                      ; push length on stack
        call    Get$Alloc               ; allocate string space
        push    AX                      ; save handle for exit
        push    AX                      ; push it on stack
        call    Get$Loc                 ; get location of new string
        mov     ES,DX                   ; put segment in ES
        mov     DI,AX                   ; put offset in DI
;--- Position Pointer to End of New String ---
        add     DI,CX                   ; move offset to end of target string
        inc     CX                      ; account for last char '0'
CopyString:
        mov     AL,DS: [SI]             ; get char from source string
        mov     ES: [DI],AL             ; put it in destination string
        dec     SI                      ; move to prev char in source
        dec     DI                      ; move to prev char in target
        loop    CopyString              ;
        pop     AX                      ; get new string handle
Exit:
        push    AX                      ; save return val
        push    Word Ptr StrHandle      ; push passed string handle
        call    Rls$Alloc               ; release passed string
        pop     AX                      ;
        pop     DS                      ;
        pop     BP                      ;
        retf    Retbytes                ;
triml   EndP
MCODE EndS
        End
