; QBUTTON - Print a 3D button on the screen with one or more highlighted
;           characters.
;
; Row    = Screen row to display text
; Col    = Starting column to display text
; Text   = Text string to display on screen, use tilde (~) to separate
;          highlighted characters; "~H~ello"
; Attr   = Color attribute to display characters
;;HlAttr = Color to display highlighted characters
;
;B QBUTTON(BYVAL Row AS INTEGER, BYVAL Col AS INTEGER, _
;           BYVAL Text AS STRING, BYVAL Attr AS BYTE, _
;           BYVAL HlAttr AS BYTE) PUBLIC
;
Extrn   Get$Loc: Far
Extrn   Rls$Alloc: Far

MCODE Segment Byte
        Assume  CS: MCODE

        Public  xbut

xbut     Proc Far

ARG     HlAttr:BYTE, ATTR:BYTE, StrHandle:WORD, COL:WORD, ROW:WORD = Retbytes
         jmp ODATA
           hlength  DW 0h
ODATA:
    push    BP              ;
    mov     BP,SP           ;
    push    DS              ;
                            ; GET STRING POINTER
    mov     AX, StrHandle   ; put string handle in AX
    push    AX              ; push it on the on stack
    call    Get$Loc         ; get location of string
    jcxz QBExit             ; if it's null, exit

    mov  DS, DX             ; put segment in DS
    mov  SI, AX             ; put offset in SI

    mov  AX, 47104          ; put screen segment in AX
    mov  ES, AX             ; move to ES

    push CX                 ; save length
    mov  AX, Row            ; put row in AX
    dec  AX                 ; minus one
    mov  CX, 160            ; AX =
    mul  CX                 ;   AX * 160
    mov  DI, AX             ; put it in DI
    mov  AX, Col            ; put column in AX
    dec  AX                 ; minus one
    shl  AX, 1              ; times 2
    add  DI, AX             ; add to DI
    pop  CX                 ; restore length of string

    mov  AH, Attr           ; put attribute in AH
    mov  DH, HlAttr         ; get highlight attribute
    mov  hlength, CX        ; save length

    push DI                 ; save DI
WriteBChar:
    lodsb                   ; get char from string
    cmp  AL, 64             ; "@" char?
    jne  NoSwitch           ; no, write the char
    xchg AH, DH             ; swap attributes
    dec  hlength            ; one less in saved length
    jmp  Short SkipWrite    ;
NoSwitch:
    stosw                   ; write char and attribute to screen
SkipWrite:
    loop WriteBChar         ; do it all CX times

    mov  AX, ES             ; put screen segment in AX
    mov  DS, AX             ; and in DS
    mov  SI, DI             ; move screen pointer to SI
    lodsw                   ; get next byte and attribute
    and  AH, 01110000b      ; isolate background color
    or   AH, AH             ; zero?
    jnz  WriteEnd           ; no, write the button end
    mov  AH, 0              ; use white foreground
WriteEnd:
    mov  AL, 220            ; char for button
    stosw                   ; write right side of button 'effect'

    pop  DI                 ; restore start of line
    add  DI, 162            ; move to next row plus one char
    mov  CX, hlength        ; put string length in CX
WriteShadow:
    mov  SI, DI             ; move screen pointer to SI
    lodsw                   ; get next byte and attribute
    and  AH,   01110000b    ; isolate background color
    or   AH, AH             ; zero?
    jnz  WriteBottom        ; no, write the button bottom
    mov  AH, 0              ; use white foreground
WriteBottom:
    mov  AL, 223            ; char for button
    stosw                   ; write bottom of button 'effect'
    loop  WriteShadow       ; do it CX times

QBExit:
        push    Word Ptr StrHandle      ; push string handle
        call    Rls$Alloc               ; release string
        pop     DS                      ; restore DS for PowerBASIC
        pop     BP                      ;
        retf    Retbytes                ;
xbut     EndP
MCODE EndS
        End


